<template>
  <v-row id="yourID" justify="center" no-gutters>
    <!-- <v-dialog v-model="dialogEntitiesCreate" retain-focus persistent width="800px"> -->
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-notebook</v-icon
            ><b>{{ titleDialogCreate }}</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <v-card-text>
        <v-form ref="form" v-model="valid">
          <v-container>
            <v-row>
              <v-col class="mb-n1 mt-n3" cols="12" sm="12" md="12">
                <v-text-field
                  autofocus
                  v-model="entity.name"
                  label="Código da entidade*"
                  required
                  prepend-icon="mdi-pencil-box-outline"
                ></v-text-field>
              </v-col>
              <!-- Pesquisar entidades -->
              <v-row style="width: 100%; display: flex; align-items: center;" class="mb-2" justify="center" no-gutters>
                <span style="margin-right: 4px; font-size: 15px; ">
                    <v-icon class="mr-1">mdi-book-multiple-outline</v-icon> Entidade Pai: *
                  </span>
                <v-col v-if="!showEdit" class="pl-4 mt-n7 mb-6" style="position: relative" cols="9">
                  <v-autocomplete
                    class="mt-6"
                    v-model="entity.parentId"
                    :search-input.sync="entityToSearch"
                    :items="resultOfSearch"
                    hide-details
                    hide-no-data
                    hide-selected
                    item-text="name"
                    item-value="id"
                    :label="result"
                    />
                    <!-- @input="addTemporary()" -->
                  <!-- Resultado da pesquisa entidade -->
                  <section
                    style="position: absolute; bottom: -30px; left: 30%"
                    v-if="searchClean && resultOfSearch.length > 0"
                  >
                    Existem
                    <b>{{ resultOfSearch.length }}</b> entidades selecionáveis.
                  </section>
                  <!-- Fim resultado pesquisa entidade -->
                </v-col>
              </v-row>
              <!-- Fim pesquisar entidades -->
              <!-- Modulos -->
              <v-col v-if="!showEdit" class="mt-2" cols="6" sm="12" md="6">
                <v-select
                  v-model="entity.modules"
                  prepend-icon="mdi-book-outline"
                  multiple
                  :items="itemsModules"
                  item-text="label"
                  item-value="id"
                  label="Módulos"
                  dense
                ></v-select>
              </v-col>
              <!-- Fim Módulos -->
              <v-col class="mt-2" cols="6" sm="12" md="6">
                <v-text-field
                  class="pa-0 ma-0"
                  v-model="entity.firstName"
                  label="Nome (não obrigatório)"
                  required
                  prepend-icon="mdi-pencil"
                ></v-text-field>
                <!-- <v-text-field
                  :disabled="showEdit"
                  class="pa-0 ma-0"
                  v-model="entity.firstName"
                  label="Nome principal"
                  required
                  prepend-icon="mdi-pencil"
                ></v-text-field> -->
              </v-col>
              <v-col cols="6" sm="12" md="6">
                <v-text-field
                  class="pa-0 ma-0"
                  v-model="entity.initialDate"
                  v-mask="mask"
                  placeholder="dd/mm/aaaa"
                  label="Data de ínicio"
                  required
                  prepend-icon="mdi-calendar"
                  @input="saveEntityDate"
                ></v-text-field>
              </v-col>
              <v-col cols="6" sm="12" md="6">
                <v-text-field
                  class="pa-0 ma-0"
                  v-model="entity.endDate"
                  placeholder="dd/mm/aaaa"
                  v-mask="mask"
                  label="Data final"
                  required
                  prepend-icon="mdi-calendar-outline"
                  @input="saveEntityDate"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="12">
                <!--prettier-ignore-->
                <v-row align="center">
                    <v-checkbox
                      v-model="entity.visible"
                      color
                      label="Entidade visível?"
                      class="my-0 ml-3 mt-n2 pa-0"
                    ></v-checkbox>
                  </v-row>
              </v-col>
              <v-col cols="12" class="mt-n6">
                <small><b>* campo obrigatório</b></small>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions class="mt-n12 pb-6 pr-6">
        <v-spacer />
        <v-btn color="secondary" text @click="handleClose">Cancelar</v-btn>
        <!--prettier-ignore-->
        <v-btn
            v-if="!showEdit"
            :disabled="!entity.name || entity.parentId === '' "
            elevation="0"
            color="primary"
            class="px-4"
            @click="confirmCreate"
          >Adicionar</v-btn>
        <v-btn v-if="showEdit" class="px-4" color="primary" elevation="0" @click="handleEdit"
          >Editar</v-btn
        >
      </v-card-actions>
    </v-card>
    <!-- </v-dialog> -->
  </v-row>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import User from '../../services/user'
import Management from '../../services/management'
import { mask } from 'vue-the-mask'

export default {
  name: 'EntitiesCreate',
  components: {},
  directives: {
    mask,
  },
  props: {
    titleDialogCreate: {
      type: String,
      default: 'BOTE UM TITULO',
    },
    itemsModules: {
      type: Array,
      default: () => [],
    },
    dialogEntitiesCreate: {
      type: Boolean,
      default: false,
    },
    itemsEntity: {
      type: Array,
      default: () => [],
    },
    itemToEdit: {
      type: Object,
      default: () => {},
    },
    showEdit: {
      type: Boolean,
      default: false,
    },
    entities: {
      type: Array,
      default: () => [],
    },
  },
  data: () => ({
    confirmValueCount: 0,
    hoverAdd: false,
    entity: {
      modules: [],
      parentId: '',
      name: '',
      firstName: '',
      visible: true,
      initialDate: '',
      endDate: '',
    },
    resultOfSearch: [],
    entityToSearch: '',
    temporarySelectedEntities: [],
    temporarySelectedEntitiesInfo: [],
    selectedEntityName: '',
    searchClean: false,
    label: {
      initial: 'Digite o nome da entidade ou p/ buscar todas deixe o campo vazio e de ok.',
      noResult: 'Desculpe, nenhuma entidade encontrada',
      result: 'Selecione a entidade.',
    },
    result: 'Digite o nome da entidade ou p/ buscar todas deixe o campo vazio e de ok.',
    mask: '##/##/####',
    valid: false,
    itemEntity: [],
    isLoading: false,
    items: [],
    tab: null,
  }),
  async created() {
    // console.log(this.itemToEdit, 'item para editar')
    this.itemToEdit.initialDate = this.formatDate(this.itemToEdit.initialDate);
    this.itemToEdit.endDate = this.formatDate(this.itemToEdit.endDate);

    this.entity = {...JSON.parse(JSON.stringify(this.itemToEdit))}
   
    await this.searchEntities()
  },
  computed: {
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
  },
  watch: {
    'itemToEdit.id'() {
      console.log('watch');
      this.entity = JSON.parse(JSON.stringify(this.itemToEdit))
    },
    // itemToEdit() {
    //   this.entity = JSON.parse(JSON.stringify(this.itemToEdit))
    // },
    dialogEntitiesCreate() {
      if (this.dialogEntitiesCreate) this.searchEntities()
    },
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        this.handleClose()
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },
  },
  methods: {
    ...mapMutations('user', ['UPDATE_ENTITIES_CREATE', 'ADD_COURSE']),
    cleanSearch() {
      this.entityToSearch = ''
      this.searchClean = false
      this.resultOfSearch = []
      this.temporarySelectedEntities = []
      this.selectedEntityName = ''
      this.result = this.label.initial
    },
    //array de Ids
    showSelected(ids) {
      if (this.resultOfSearch.length > 0)
        this.resultOfSearch.forEach((entity) => {
          if (entity.id === ids) {
            if (entity.firstName) {
              this.selectedEntityName = entity.firstName + ' / ' + entity.name
              return
            } else {
              this.selectedEntityName = entity.name
              return
            }
          }
        })
    },
    saveEntityDate() {
      const entitySaveDate = this.entity.initialDate
      const entitySaveEndDate = this.entity.endDate
    },
   
    //checa se entidade já foi adicionado ao temporário, caso não tenha sido add retorna true
    checkTemporary(id) {
      const temporaryInfo = this.temporarySelectedEntitiesInfo
      let notAdd = 0
      temporaryInfo.forEach((item) => {
        if (item.id != id) notAdd++
      })
      if (notAdd == temporaryInfo.length) return true
    },
    
    // mostra nome no v-chip
    showName(id) {
      let name = ''
      this.temporarySelectedEntitiesInfo.forEach((item) => {
        if (item.id == id) name = item.name
      })
      return name
    },

    async searchEntities(item) {
      this.result = this.label.initial
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updateEntity').id
      if (!item) {
        item = ''
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readEntityByName(entityId, actionId, item)
        this.resultOfSearch = ret.data
        this.searchClean = true

        if (this.resultOfSearch.length > 0) {
          this.result = this.label.result
        } else {
          this.result = this.label.noResult
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    handleClose() {
      this.cleanSearch()
      this.entity = {
        modules: [],
        parentId: '',
        name: '',
        firstName: '',
        visible: true,
        initialDate: '',
        endDate: '',
      }
      this.$emit('closeDialogCreate')
    },
    confirmCreate() {
      this.handleCreate()
    },
    handleCreate() {
      const initialDate = this.entity.initialDate;
      const endDate = this.entity.endDate;

      console.log("this.entity: ",this.entity);

      this.$emit('handleCreate', this.entity)
      /*this.$parent.readEntities()*/
      this.entity = {
        modules: [],
        parentId: '',
        name: '',
        firstName: '',
        visible: true,
        initialDate: '',
        endDate: '',
      }
      this.cleanSearch()
    },
    handleEdit() {
      const initialDate = this.entity.initialDate;
      const endDate = this.entity.endDate;
      console.log(this.entity);
      this.$emit('handleEdit', this.entity)

      window.location.reload();

      this.itemToEdit = {...this.entity}
      this.cleanSearch()
    },
    readEntities() {
      this.$emit('readEntitiesCreate')
    },
    formatDate(timestamp) {
      if (!timestamp) return '';

    const date = new Date(timestamp);
    console.log(date, "teste");
    const day = String(date.getDate()).padStart(2, '0');
    const month = String(date.getMonth() + 1).padStart(2, '0');
    const year = date.getFullYear();

    return `${day}/${month}/${year}`;
    },
  },
}
</script>

<style scoped></style>
